/**
 * Title: Handling - Solution to exercise 3 of the Basic Java Examination
 * Description: Application handling IO exceptions
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

// It is necessary to import this package in order to handle the IOException
import java.io.* ;

public class Handling {

    public static void main(String arg[]) {

		// It is necessary to assign a default value, since the try{} codeblock
		// could not be completed if an exception is thrown. In such a case the
		// ch variable would not be assigned!
		char ch = ' ' ;
    	Foo1 foo1 = new Foo1() ;

    	try {
			ch = foo1.doIt();
    	}
    	catch (IOException exception) {

			System.out.println() ;
			System.out.println("******** IO EXCEPTION ********") ;
			exception.printStackTrace() ;
		}
		catch (Exception exception) {

			System.out.println() ;
			System.out.println("******** GENERAL EXCEPTION ********") ;
			exception.printStackTrace() ;
		}
		finally {

			System.out.println("You pressed: " + ch) ;
			System.out.println() ;
		}

	} // End of main

} // End of class
