/**
 * Title: Moving - Solution to exercise 1 of the Base Java Examination
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;

// NOTE: this solution assumes that the applet will run in a 600x300 HTML window.
// If dimensions are different the buttons will appear somewhere else and the
// moving Label will not start from the center of the applet.
// To solve this problem, see method getSize() in exercise Sample12
public class Moving extends Applet implements ActionListener {

    Button up 		= new Button("UP") ;
    Button down 	= new Button("DOWN") ;
    Button left 	= new Button("LEFT") ;
    Button right 	= new Button("RIGHT") ;
    Button where 	= new Button("WHERE") ;
    Button start	= new Button("START") ;

    int x = 290 ;			 // beginning value for the X coordinate
    int y = 130 ;			 // beginning value for the Y coordinate
    int inc = 10 ;           // increment value of the X-Y steps

    String cmd ;
    Label sprite  = new Label("*") ;
    Label coordinates = new Label("X = " + x + ",  Y = " + y) ;

    public void init() {

		add(start) ;
        left.addActionListener(this) ;
        up.addActionListener(this) ;
        down.addActionListener(this) ;
        right.addActionListener(this) ;
        where.addActionListener(this) ;
		start.addActionListener(this) ;
    }

	// This method is not necessary if we don't mind about the layout.
	// In this exercise we want to set the locations of ALL the buttons, hence we need to do
	// this AFTER the method init() has been called.
    public void dispose() {

		add(left);
		add(up) ;
        add(down) ;
        add(sprite) ;
		add(right) ;
		add(where) ;
    	add(coordinates) ;

        invalidate() ;		// we need this because we add the labels after the init()
        validate() ;

        left.setLocation(180,10) ;
		up.setLocation(260,10) ;
		down.setLocation(300,10) ;
		right.setLocation(380,10) ;
		where.setLocation(10,270) ;
		coordinates.setLocation(500,270) ;

		start.setVisible(false) ;		// Hides the "START" button
    }


    // Moves the Label "sprite" at the coordinates (x,y)
    public void drawIt() {

        sprite.setLocation(x,y) ;
    }

    public void actionPerformed(ActionEvent event) {

        cmd = event.getActionCommand() ;

        if (cmd == "UP"   )	y-= inc ;
        if (cmd == "DOWN" )	y+= inc ;
        if (cmd == "LEFT" )	x-= inc ;
        if (cmd == "RIGHT") x+= inc ;
        if (cmd == "WHERE") coordinates.setText("X = " + x + ",  Y = " + y) ;
        if (cmd == "START") dispose() ;

		drawIt() ;
    }

} // End of applet