/**
 * Title: Moving02 - Solution to exercise 2 of the Basic Java Examination
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

// The import conditions are NOT heritated from the parent !!!
import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;

public class Moving02 extends Moving {

	Graphics graphics ;

	// Following line is wrong, since the graphic object must be retrieved AFTER the init()
	// method of the parent (see below) :
	//
	// Graphics graphics = getGraphics() ;

    public void init() {

		super.init() ; 	// invoking the init() method of the parent

		graphics = getGraphics() ;
		graphics.setFont(new Font("Helvetica", Font.PLAIN + Font.BOLD, 18)) ;
        graphics.setColor(Color.red) ;

	}

    public void drawIt() {

		// Note that clearing the whole surface will not affect the components!
		// This because the components are managed by the LayoutManager by the add() method,
		// which is independent from the Graphic object!

		graphics.clearRect(0, 0, getSize().width, getSize().height) ;
        graphics.drawString("*", x, y) ;

    }

} // End of class
