/**
 * Title: MyPrinter - Solution to exercise 4 of the Basic Java Examination
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.awt.* ;
import java.awt.print.* ;

public class MyPrinter {

	// CLASS ATTRIBUTES
	String text = "We are learning to print using Java and this is the text that we would "
	+ "like to see on the printer. Since the printing job is performed by the Painter class, "
	+ "it is necessary to use a text written on more than one row, in order to verify if the "
	+ "Painter class really does his job!"	;

    public static void main(String arg[]) {

    	MyPrinter apply = new MyPrinter() ;

    	try {

    		apply.printNow() ;
    	}
    	catch (Exception exception) {

			System.out.println("Exception: " + exception) ;
		}
	}

    public void printNow() throws Exception {

		System.out.println() ;
		System.out.println("Trying to print now!") ;
		System.out.println("Don't panic if the application stops here many seconds ...") ;

		// Retrieving a PrinterJob object using this static method:
		PrinterJob printerJob = PrinterJob.getPrinterJob() ;

		// The Book object will represent the document that we want to print
		Book book = new Book();

		// Instanciates the Painter class, which is provided with this exercise.
		Printable painter = new Painter(text);

		book.append(painter, new PageFormat());
		printerJob.setPageable(book);

		boolean doPrint = printerJob.printDialog();
		if (doPrint) { 		// The user pressed "OK" on the print dialog

			printerJob.print();
		}

		System.out.println("End of printing!") ;
		System.out.println() ;

	return ;

    }

} // End of class
