/**
 * Title:        Sample 01 -  managing a label which follows the mouse on the applet
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

// Ignore this for the time being
package adriani.tutorial.base ;

// Following code is necessary in order to use other classes:
// this class uses the java.awt.event.MouseMotionListener interface,
// that's why we need to write "import java.awt.event.*"
// Do not mind about this for the time being.
import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;

/* Since this class implements the MouseMotionListener interface, we MUST implements two methods:
 * the mouseMoved() and the mouseDragged().
 * Note: these are the only two methods of the MouseMotionListener interface !!!
 */
public class Sample01 extends Applet implements MouseMotionListener {

	// *******   CLASS ATTRIBUTES *******

    // Here we define and instantiate "follower", which  is the label
    // that will follow the mouse pointer when the user moves the mouse.
    Label follower = new Label("I follow the mouse") ;

    // Here we instantiate a Font object (see below)
    Font big = new Font("Helvetica",Font.ITALIC,28) ;

	// *******   CLASS METHODS *******

    // 1. Method inhereted by the Applet class:
    public void init() {

		// We "send" the Font-like object to the Label-like object
        follower.setFont(big) ;
        // We display the Label on the applet's surface
        add(follower) ;

        // We specify that THIS applet is the "mouse motion events" listener
        addMouseMotionListener(this) ;
    }


    // 2. Method invoked only when the mouse is moved
    public void mouseMoved(MouseEvent event) {


        follower.setLocation(event.getX(), event.getY()) ;
    }

	// 3. Method invoked only when the mouse is dragged. Note:it's
	// necessary to write this if we want to implement the MouseMotionListener interface
    public void mouseDragged(MouseEvent event) {

        follower.setLocation(50, 50) ;
		// this method DOES NOT CONTAIN CODE !!!
	}
}
