/**
 * Title:        Sample 02 -  extending the Sample 01 class and adding some labels
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.applet.* ;
import java.awt.* ;

// Note: now we DO NOT NEED to import java.awt.event, since the MouseMotionListener
// interface is now inherited from the Sample01 class !!!

public class Sample02 extends Sample01 {

    Label one    = new Label("AAAA") ;
    Label two    = new Label("BBBB") ;

    //  Defining a new Font object, smaller than the "big" Font.
    // Note: the "big" Font is inherited from the parent Sample01.
    Font  medium = new Font("Helvetica",Font.BOLD,18) ;

    public void init() {

        // The field "follower" is present in Sample02 since it is
        // inherited from the superclass Sample01 !!!
        follower.setText("I'm the child") ;

        // By calling super.init() we invoke the init() method of the parent, i.e. Sample01.
        // If i don't call this method, the mouse event will not be sent to the Sample01 class,
        // therefore this applet will not be able to move the label "follower".
        super.init() ;

		// Setting two different fonts to the two labels
        one.setFont(medium) ;
        two.setFont(big) ;

		// Adding the two labels to the applet's surface
        add(one) ;
        add(two) ;

    }
}
