/**
 * Title: Sample 05 -  testing basic AWT components
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;

/** Since the Applet implements the ActionListener interface, this class
 *  will be a listener of all events related to the components which
 *  is the target of the addActionListener() method (see below).
 */
public class Sample05 extends Applet implements ActionListener {

	// ATTRIBUTES
    TextField field = new TextField("Write ONE char here",30) ;
    Label output  	= new Label("This label will contain the output string. This is why is long") ;
    Button button 	= new Button("DO IT") ;

	// MAIN METHOD
    public void init()  {

        add(field) ;
        add(button) ;
        add(output) ;

        // Try following code to experiment the "return value rule"
        // Component pippo = add(output) ;
        // output.setText("***" + pippo.toString()) ;

        // The listener (this applet) will receive events from this button
        button.addActionListener(this) ;
    }

	// This method will be invoked when the button is pressed
    public void actionPerformed(ActionEvent event) {

		// Defining some local fields (not class attributes)
        String input = field.getText() ;
        char char1    = input.charAt(0) ;

		// Implicit cast
		int n = char1 ;
		String result = "Input is: " + char1 + " (code:" + n + "). " ;

		// Explicit cast
        char char2 = (char) ++n ;

        result += "Next char is: " + char2 + " (code:" + n + ")" ;

        output.setText(result) ;
    }

}