/**
 * Title: Sample 06 - testing basic AWT components
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;

// Class header
public class Sample06 extends Applet implements ActionListener {

    Label comment = new Label("Insert two numbers, then press 'Compute'") ;
    Button press  = new Button("Compute") ;

	// Input fields
    TextField input1 = new TextField(2) ;
    TextField input2 = new TextField(2) ;

    // Output fields
    TextField next   = new TextField(2) ;
    TextField half   = new TextField(4) ;

	// Setting some default values, close to the maximum ranges
	// This is needed in order to begin with negative numbers (see below)
	int    n = (int) -2.0E18 ;
    double d = 1.0E300 ;

	// This method is invoked by pressing the "Compute" Button
    public void actionPerformed(ActionEvent pressed) {

		// Local variables. They exist only inside this method
		int ntemp ;
		double dtemp ;

		// Parsing the text fields in order to obtain numbers
		ntemp			= Integer.parseInt( input1.getText() ) ;
        Double wrapper  = Double.valueOf(   input2.getText() ) ;
        dtemp			= wrapper.doubleValue() ;

        // This code is to enphantize the end of the input process
        input1.setEditable(false) ;
        input2.setEditable(false) ;

		// This code emulate a "IF ... THEN" structure
		// Since 'n' and 'd' have huge initial values, using this code
		// we read the TextFields input1 and input2 only the first time.
        n = (n > ntemp) ? n : ntemp ;
        d = ( Math.abs(d) < Math.abs(dtemp) ) ? d : dtemp ;

        // Updating the class fields
        n++ ;
        d = d/2 ;

		// Setting outputs
        next.setText("" + n) ;
        half.setText("" + d) ;

    }

    public void init() {

        press.addActionListener(this) ;

		// The output fields do not need to be editable
        next.setEditable(false) ;
        half.setEditable(false) ;

        add(comment) ;
        add(input1) ;
        add(input2) ;
        add(press) ;
        add(next) ;
        add(half) ;

    }
}