/**
 * Title: Sample 09 - testing different loops
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */


package adriani.tutorial.base ;

import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;

public class Sample09 extends Applet implements ActionListener {

    Label label     = new Label("Select one : ") ;
    Button button1  = new Button("WHILE") ;
    Button button2  = new Button("DO-WHILE") ;
    Button button3  = new Button("SWITCH") ;

    int maxLoop = 4 ;
    short size 	= 400 ;

	// The Graphic object bound to this Component (the Applet)
    Graphics graphics ;

    public void init() {

        add(label) ;
        add(button1) ;
        add(button2) ;
        add(button3) ;

        button1.addActionListener(this) ;
        button2.addActionListener(this) ;
        button3.addActionListener(this) ;

		// Set default font and color for the drawString() method
    	graphics = getGraphics() ;
        graphics.setFont(new Font("Helvetica", Font.PLAIN, 12)) ;
        graphics.setColor(Color.BLACK) ;
    }

	// Method invoked when a button is pressed
    public void actionPerformed(ActionEvent event) {

        // Retrieves the label of the button which has been pressed.
        // Note: using event.getSource() we'd have the Object itself.
        String word = event.getActionCommand() ;
        char firstLetter = word.charAt(0) ;

		// Cleans the Applet surface's each time a button is pressed.
        graphics.clearRect(0, 0, size, size) ;

        int i = 0 ;		// integer variable used by the three loops

		// Switches among the three cases: WHILE, DO and SWITCH
        switch (firstLetter) {

		// Action performed if the WHILE button is pressed
        case 'W' :

            graphics.setColor(Color.BLUE) ;

            while (i < maxLoop) {
            	i++ ;
            	graphics.drawString("While: step N. " + i, 100, 100 + 20*i) ;
            	if (i == 2) continue ;
            	graphics.drawString("PERFORMED", 250, 100 + 20*i) ;

            }

        	break ;

		// Action performed if the DO-WHILE button is pressed
        case 'D' :

            graphics.setColor(Color.RED) ;

            do {
                i ++ ;
                graphics.drawString("Do: step N. " + i,100,100 + 20*i) ;
                if (i == 2) break ;
                graphics.drawString("PERFORMED",250,100 + 20*i) ;
            } while (i < maxLoop) ;

        	break ;

		// Action performed if the SWITCH button is pressed
        case 'S' :

            graphics.setColor(Color.YELLOW) ;

            // Produce a random number between 1 and maxLoop
            Random random = new Random() ;
            double result = random.nextDouble() ;
            i = (int) (result*maxLoop) + 1 ;

        	switch (i) {
                case 1:   graphics.drawString("Switch: case N. 1",100,100) ;
                          break ;
                case 2:   graphics.drawString("Switch: case N. 2",100,120) ;
                          break ;
				default:  graphics.drawString("Switch: default " + i,100,180) ;
                          break ;
                case 3:   graphics.drawString("Switch: case N. 3",100,140) ;
                          break ;
				case 4:   graphics.drawString("Switch: case N. 4",100,160) ;
                          break ;

            }
        	break ;

        }	// End of the main switch ("W", "D" and "S" case)

    }	// End of the actionPerformed() method

} // End of class