/**
 * Title: Sample 10 - Application for testing System.in, Calendar and Vectors
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.util.* ;
import java.io.* ;

public class Sample10 {

	// CLASS ATTRIBUTES
	GregorianCalendar calendar = new GregorianCalendar() ;
	Vector history = new Vector(5) ;
	char input = 'a' ;   // dummy value required by the readKey() method

    public static void main(String arg[]) throws Exception {

    	Sample10 sample = new Sample10() ;
    	sample.loop() ;
	}

	// Main method for this application
    public void loop() throws Exception {

    	String date = "" ;
		boolean quit = false ;

		// This section loops until a valid entry is entered
		do {

			input = readKey() ;
        	switch (input) {
                case '1': System.out.println("Today is " + returnDate() ) ;
                          break ;
                case '2': insertTime() ;
                          break ;
				case '3': showTimes() ;
				          break ;
				case '4': quit = true ;
                          break ;
				default:  quit = false ;
            }

    	} while (!quit) ;

    	System.out.println() ;
    }

	// Method used to retrieve the key pressed by the user
    public char readKey() throws Exception {

		boolean isOK = Character.getNumericValue(input) > 0 ;

		if (isOK) {		// this check avoids printing menu for chr(13) and chr(10)

			System.out.println() ;
			System.out.println("***   TESTING CALENDAR ***") ;
			System.out.println("Please enter one of the following:") ;
			System.out.println() ;
			System.out.println("1) To get current time using GregorianCalendar") ;
			System.out.println("2) To insert current time into History") ;
			System.out.println("3) To retrieve History content") ;
			System.out.println("4) Quit this application") ;
		}

        char c1 = (char) System.in.read() ;
        if (isOK) System.out.println() ;

        return c1 ;
    }

	// Used to print the message "Today is ..."
    public String returnDate() {

		int day = calendar.get(Calendar.DAY_OF_MONTH) ;
		int month = 1 + calendar.get(Calendar.MONTH) ;
		int year = calendar.get(Calendar.YEAR) ;

		return day + "-" + month + "-" + year ;
    }

	// Used to insert the "String + Date" object into the Vector
	public void insertTime() {

		calendar = new GregorianCalendar() ;	// necessary to update number of seconds
		history.addElement("Time: " + calendar.getTime()) ;

		return;
    }

	// Used to list all the elements in the Vector
    public void showTimes() {

		for (int i = 0; i < history.size(); i++)
			System.out.println(i + ") " + history.elementAt(i) ) ;

		System.out.println("Current capacity is: " + history.capacity() ) ;

		return ;
    }

} // End of class
