/**
 * Title: Sample 11 - The applet life cycle and the paint() method
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Morpheus
 * @author Stefano Adriani
 * @version 1.0
 */

package adriani.tutorial.base ;

import java.applet.* ;
import java.awt.* ;
import java.awt.event.* ;

public class Sample11 extends Applet implements ActionListener {

    int N_start, N_stop, N_destroy, N_paint, N_init ;

	Graphics myGraphic ;
    Label  test  = new Label("Sorry, I'm late ...") ;
    Button press = new Button("Test") ;

    boolean goodCode = false ;		// shortcut allowing two ways of compilation

    public void actionPerformed(ActionEvent event) {

        add(test) ;
        invalidate() ;		// Try to comment these two lines and the applet will not
        validate() ;		// show the Label "test" on the surface !
		//repaint() ;		// In this case repaint() is completely unuseful.

		// This is bad code since the paint() method will not repaint this string,
		// simply because this string is not listed in the paint() method!
		if (!goodCode) myGraphic = getGraphics() ;
		myGraphic.drawString("To appear or not to appear?", 10, 160) ;
    }

    public void init() {

        N_init++ ;
        add(press) ;
        press.addActionListener(this) ;
    }

    public void start()   { N_start++;    repaint(); }

    public void stop()    { N_stop++;	  repaint(); }

    public void destroy() { N_destroy++;  repaint(); }

    public void paint(Graphics graphic) {

        N_paint++ ;

	    graphic.setFont(new Font("Helvetica", Font.PLAIN, 18)) ;
        graphic.setColor(Color.DARK_GRAY) ;
        graphic.drawString("init() : "    + N_init, 10, 50) ;
        graphic.drawString("start() : "   + N_start, 10, 70) ;
        graphic.drawString("stop() : "    + N_stop, 10, 90) ;
        graphic.drawString("paint() : "   + N_paint, 10, 110) ;
        graphic.drawString("destroy() : " + N_destroy, 10, 130) ;

    	if (goodCode) myGraphic = graphic ;
    }

} // End of class